//
//	FileDivide.c
//
#include	<AjrCstXX.h>
#include	<math.h>
#include	<tchar.h>
#include	<shlwapi.h>
#include	"resource.h"

#define		MB				((ULL)(1024 * 1024))
#define		BUFSIZE			4096
#define		LEN_DIVSTR		10
#define		TID_ENABLE_SET_TXT_OLDIR	1

#define		MYSECT			TEXT("SETTING")
#define		REG_PATH		TEXT("SOFTWARE\\AjrCstXX\\FileDivide")
#define		MUTE_DUP_APP	TEXT("AJrFileDivideSetting")

//--------------------------------------------------------------------------------------------------------------//
//	i																									//
//--------------------------------------------------------------------------------------------------------------//
#define	MYSECT	TEXT("SETTING")
static	UI		DivSize = 16;			//	TCY[MB]
static	BOOL	fDivDir  = TRUE;		//	t@Ci[Ii0: t@CƓ, 1: w肵ꏊj
static	BOOL	fDivOpen = TRUE;		//	t@C̕IAt@C̏ꏊJ
static	BOOL	fDivRmv = TRUE;			//	ɁA̕t@Cꍇ͍폜
static	UT		DivDir[MAX_PATH];		//	t@Ci[tH_

static	BOOL	fMrgDir  = TRUE;		//	t@Ci[Ii0: t@CƓ, 1: w肵ꏊj
static	BOOL	fMrgOpen = TRUE;		//	t@C̓IAt@C̏ꏊJ
static	BOOL	fMrgRmv  = TRUE;		//	t@C̓ꍇAt@C폜
static	UT		MrgDir[MAX_PATH];		//	t@Ci[tH_

static	UT		OutlookDir [MAX_PATH];	//	Outlook.exe ̃tH_pX
static	UT		OutlookDesc[MAX_PATH];	//	Outlook.exe ̋Lq
static	UT		OutlookVer [MAX_PATH];	//	Outlook.exe ̃o[W

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
HINSTANCE		hInst;							//	CX^Xnh
HANDLE			hMuteDupSetting	= NULL;			//	ݒ̓dN}~p~[ebNX
HWND			hDlgMain;						//	_CAOnhiʁj
HWND			hDlgDivide;						//	_CAOnh
HWND			hDlgMerge;						//	_CAOnh
HWND			hDlgSetting;					//	ݒ_CAOnh
HICON			hIcoDivide;
HICON			hIcoHelp;
UT				ArgPath	[MAX_PATH];				//	R}hC̃pX
BOOL			fBusy	= FALSE;				//	^tO
BOOL			fCan	= FALSE;				//	~tO
UT				OrgFName[MAX_PATH];				//	IWit@C( <OrginalFileName>(yymmdd-hhmmss).ext )
UT				Version[64];					//	o[W

UT				OlkDesc[256]	  = {0};		//	i
UT				OlkVer [256]	  = {0};		//	o[W
UT				OlkDir [MAX_PATH] = {0};		//	fBNgpX

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Divide);
AJC_DLGPROC_DEF(Merge);
AJC_DLGPROC_DEF(Setting);
AJC_WNDPROC_DEF(DlgSub);

static	BOOL	ConvertToNormalName(C_UTP pDiv, UT buf[MAX_PATH]);
static	VO		EraseDivideFiles(C_UTP pOrg);
static	UI		IsDivFmtInFName(C_UTP pFName);
static	UI		IsDivFmtStr(C_UTP pStr);
static	BOOL	CorrectDivideFiles(HAJCAVS hAvs, UI maxnum);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;
	UI		argc;
	UTP		*argv;
	UT		fname[MAX_PATH];
	UT		fext [MAX_PATH];
	UT		DefDir[MAX_PATH];

	hInst = hInstance;

	//----- Outlooki[tH_ǂݏo ----------------//
	//	CXg[̐ݒl
	AjcSetRegTopKey(HKEY_LOCAL_MACHINE);
	AjcGetRegFileStr(REG_PATH, MYSECT, TEXT("OutlookDir" ), TEXT(""), OutlookDir , AJCTSIZE(OutlookDir ));
	AjcGetRegFileStr(REG_PATH, MYSECT, TEXT("OutlookDesc"), TEXT(""), OutlookDesc, AJCTSIZE(OutlookDesc));
	AjcGetRegFileStr(REG_PATH, MYSECT, TEXT("OutlookVer" ), TEXT(""), OutlookVer , AJCTSIZE(OutlookVer ));
	AjcSetRegTopKey(HKEY_CURRENT_USER);

	//	_CAOJ[ݒ
	AjcDgcSetup();

	//----- ACRǂݏo ---------------------------//
	hIcoDivide = LoadIcon(hInst, MAKEINTRESOURCE(IDI_DIVIDE));
	hIcoHelp   = LoadIcon(hInst, MAKEINTRESOURCE(IDI_HELP));

	//----- ftHgi[tH_ݒ -----------------//
	GetTempPath(MAX_PATH, DefDir);
	AjcPathCat(DefDir, TEXT("FileDiv"), MAX_PATH);
	CreateDirectory(DefDir, NULL);
	PathRemoveBackslash(DefDir);
	//----- iǂݏo ---------------------------//
	DivSize  = AjcGetProfileUInt(MYSECT, TEXT("DivSize" ), 16);
	fDivDir  = AjcGetProfileUInt(MYSECT, TEXT("fDivDir" ), TRUE);
	fDivOpen = AjcGetProfileUInt(MYSECT, TEXT("fDivOpen"), TRUE);
	fDivRmv  = AjcGetProfileUInt(MYSECT, TEXT("fDivRmv" ), TRUE);
	AjcGetProfileStr(MYSECT, TEXT("DivDir"), DefDir, DivDir, MAX_PATH);

	fMrgDir  = AjcGetProfileUInt(MYSECT, TEXT("fMrgDir" ), TRUE);
	fMrgOpen = AjcGetProfileUInt(MYSECT, TEXT("fMrgOpen"), TRUE);
	fMrgRmv  = AjcGetProfileUInt(MYSECT, TEXT("fMrgRmv" ), TRUE);
	AjcGetProfileStr(MYSECT, TEXT("MrgDir"), DefDir, MrgDir, MAX_PATH);

	//	AvŕύXꍇ́A
	AjcGetProfileStr(MYSECT, TEXT("OutlookDir" ), TEXT(""), OlkDir , AJCTSIZE(OlkDir ));
	AjcGetProfileStr(MYSECT, TEXT("OutlookDesc"), TEXT(""), OlkDesc, AJCTSIZE(OlkDesc));
	AjcGetProfileStr(MYSECT, TEXT("OutlookVer" ), TEXT(""), OlkVer , AJCTSIZE(OlkVer ));
	if (OlkDir[0] != 0) {
		MAjcStrCpy(OutlookDir , AJCTSIZE(OutlookDir ), OlkDir );
		MAjcStrCpy(OutlookDesc, AJCTSIZE(OutlookDesc), OlkDesc);
		MAjcStrCpy(OutlookVer , AJCTSIZE(OutlookVer ), OlkVer );
	}

	//----- R}hC -------------------------//
	argv = AjcParseCmdArgsEx(szCmdLine, &argc, TRUE);
	if (argc == 0) {
		//	ݒ_CAOI[v
		hDlgMain = hDlgSetting = CreateDialog(hInst, MAKEINTRESOURCE(IDD_SETTING), NULL, AJC_DLGPROC_NAME(Setting));
		ShowWindow(hDlgSetting, SW_SHOW);
	}
	else {
		if (GetLongPathName(argv[0], ArgPath, MAX_PATH) == 0) {
			MAjcStrCpy(ArgPath, MAX_PATH, argv[0]);
		}
		//	t@CɁu(mm_of_nn)v邩ƁAgq(.divide)`FbN
		MAjcSplitPath(ArgPath, NULL, NULL, fname, fext);
		if (IsDivFmtInFName(fname) && MAjcStrICmp(fext, TEXT(".divide")) == 0) {
			//	_CAOI[v
			hDlgMain = hDlgMerge = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MERGE), NULL, AJC_DLGPROC_NAME(Merge));
			ShowWindow(hDlgMerge, SW_SHOW);
		}
		else {
			//	_CAOI[v
			hDlgMain = hDlgDivide = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIVIDE), NULL, AJC_DLGPROC_NAME(Divide));
			ShowWindow(hDlgDivide, SW_SHOW);
		}
	}
	AjcReleaseCmdArgs(argv);

	//	_CAOTuNXiENbNj[j
	MAjcMmpSetSubclass(DlgSub, hDlgMain);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	//----- ACR -------------------------------//
	DeleteObject(hIcoDivide);

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																				//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, WM_INITDIALOG	)
{
	POINT	pt;
	UT		FileName[MAX_PATH];
	UT		fname[MAX_PATH];
	UT		fext [MAX_PATH];

	hDlgDivide = hDlg;

	//	peLXg
	SetWindowText(hDlg, AJCLNGSEL(TEXT("t@C̕"), TEXT("File to Divide")));
	if (AjcGetLangId() != AJCLID_JPN) {
		AjcSetDlgItemStr(hDlg, IDC_LBL_INPFILE, TEXT("File to devide"));
		AjcSetDlgItemStr(hDlg, IDOK 		  , TEXT("Start dividing files"));
		AjcSetDlgItemStr(hDlg, IDC_CMD_STOP   , TEXT("Stop"));
		AjcSetDlgItemStr(hDlg, IDC_CMD_TO	  , TEXT("Reg."));
		AjcSetDlgItemStr(hDlg, IDC_CMD_SUBJECT, TEXT("Reg"));
		AjcSetDlgItemStr(hDlg, IDC_CHK_OUTLOOK, TEXT("Open outlook with divided file attachment"));
		AjcSetDlgItemStr(hDlg, IDC_LBL_TO	  , TEXT("To"));
		AjcSetDlgItemStr(hDlg, IDC_LBL_SUBJECT, TEXT("Subject"));
		AjcSetDlgItemStr(hDlg, IDC_LBL_NOTE   , TEXT("\"&&N&&\" in the subject line is converted to the number of divisions \"m / n\""));
	}

	//	c[`bv
	AjcTipTextAdd (GetDlgItem(hDlg, IDC_CHK_OUTLOOK),
				  AJCLNGSEL(TEXT("t@CYt Outlook MV[g𐶐܂B\n")
							TEXT("MpV[gɂ́A炩߈i[AhXjƌݒ肳܂B\n")
							TEXT("́u&N&v́Aԍ\"m / n\"ɕϊ܂Biex. \"(&N&)\"j--> \"(2 / 3)\""),
							TEXT("Generate an Outlook spreadsheet with attached split files.\n")
							TEXT("The destination (email address) and subject are preset on the transmission sheet.\n")
							TEXT("\"&N&\" in the subject line will be converted to the division number \"m / n\". (ex. \"(&N&)\"j--> \"(2 / 3)\")")));

	AjcTipTextAdd (GetDlgItem(hDlg, IDC_RBT_QST),
				  AJCLNGSEL(TEXT("Outlook֎w肷p^( ? / & )o[WƂɈقȂ邽߂̑IłB\n")
							TEXT("MpV[gɈ⌏ɐݒ肳Ȃꍇ́Au&vIĂB"),
							TEXT("Generate an Outlook send sheet with attached divided files.\n")
							TEXT("If the recipient and subject are not set correctly on the transmission sheet, select \"&\".")));

	AjcTipTextAdd (GetDlgItem(hDlg, IDC_RBT_ANP),
				  AJCLNGSEL(TEXT("Outlook֎w肷p^( ? / & )o[WƂɈقȂ邽߂̑IłB\n")
							TEXT("MpV[gɈ⌏ɐݒ肳Ȃꍇ́Au?vIĂB"),
							TEXT("Generate an Outlook send sheet with attached divided files.\n")
							TEXT("If the recipient and subject are not set correctly on the transmission sheet, select \"?\".")));

	AjcTipTextAdd (GetDlgItem(hDlg, IDC_CMD_TO),
				  AJCLNGSEL(TEXT("i[AhXj̃Xgɒǉ܂B\n")
							TEXT("Xg獀ڂ폜ɂ́ÁENbNj[IĂB"),
							TEXT("Add recipients (email addresses) to the list on the left.\n")
							TEXT("To remove an item from the list, right-click the  on the left and select the menu.")));

	AjcTipTextAdd (GetDlgItem(hDlg, IDC_CMD_SUBJECT),
				  AJCLNGSEL(TEXT("̃Xgɒǉ܂B\n")
							TEXT("Xg獀ڂ폜ɂ́ÁENbNj[IĂB"),
							TEXT("Add the subject to the list on the left.\n")
							TEXT("To remove an item from the list, right-click the  on the left and select the menu.")));

	//	ACR\
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcoDivide);
	//	vOXo[Wݒ
	AjcSetDlgItemPgsRange(hDlg, IDC_PGS, 0, 100);
	//	w肵t@C\
	MAjcSplitPath(ArgPath , NULL, NULL, fname, fext);
	MAjcMakePath (FileName, NULL, NULL, fname, fext);
	AjcSetDlgItemStr(hDlg, IDC_TXT_FNAME, FileName);
	//	Outlookݒ̃O[
	if (OutlookDir[0] == 0) {
		AjcEnableDlgGroup(hDlg, IDC_GRP_OUTLOOK, FALSE, FALSE);
		AjcSetDlgItemChk(hDlg, IDC_CHK_OUTLOOK, FALSE);
	}
	//	R{{bNXTuNX
	AjcSbcComboBox	   (GetDlgItem(hDlg, IDC_CBO_TO		), 30, 511);
	AjcSbcEnableLongTip(GetDlgItem(hDlg, IDC_CBO_TO		), TRUE);
	AjcSbcTipCtrl	   (GetDlgItem(hDlg, IDC_CBO_TO		), TRUE);

	AjcSbcComboBox	   (GetDlgItem(hDlg, IDC_CBO_SUBJECT), 30, 511);
	AjcSbcEnableLongTip(GetDlgItem(hDlg, IDC_CBO_SUBJECT), TRUE);
	AjcSbcTipCtrl	   (GetDlgItem(hDlg, IDC_CBO_SUBJECT), TRUE);

	//	_CAOڏ
	AjcSetDlgItemChk(hDlg, IDC_CHK_OUTLOOK, FALSE);
	AjcSetDlgItemChk(hDlg, IDC_RBT_QST	  , TRUE);
	//	outlookݒ胍[h
	AjcLoadAllControlSettings(hDlg, TEXT("OutlookSettings"), AJCCTL_SELACT_ALL | AJCCTL_SELACT_NTCCHK);

	//	EChJ[\ʒuֈړ
	GetCursorPos(&pt);
	SetWindowPos(hDlg, NULL, pt.x, pt.y, 0, 0, SWP_NOSIZE);
	AjcMoveWndIntoMonitor(hDlg);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, WM_DESTROY		)
{
	//	outlookݒZ[u
	AjcSaveAllControlSettings(hDlg);

	PostQuitMessage(0);
	return TRUE;
}
//----- ~{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, IDC_CMD_STOP	)
{
	PostMessage(hDlg, WM_COMMAND, IDCANCEL, (LPARAM)GetDlgItem(hDlg, IDCANCEL));
	return TRUE;
}
//----- o^{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, IDC_CMD_TO		)
{
	HWND	hCbo = GetDlgItem(hDlg, IDC_CBO_TO);
	HWND	hEdt = AjcSbcGetEditCtrlInComboBox(hCbo);
	UT		txt[512];

	AjcGetCtrlStr(hEdt, txt, AJCTSIZE(txt));
	SendMessage(hCbo, CB_INSERTSTRING, 0, (LPARAM)txt);
	AjcSbcSetMostNew (hCbo);
	return TRUE;
}
//----- o^{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, IDC_CMD_SUBJECT	)
{
	HWND	hCbo = GetDlgItem(hDlg, IDC_CBO_SUBJECT);
	HWND	hEdt = AjcSbcGetEditCtrlInComboBox(hCbo);
	UT		txt[512];

	AjcGetCtrlStr(hEdt, txt, AJCTSIZE(txt));
	SendMessage(hCbo, CB_INSERTSTRING, 0, (LPARAM)txt);
	AjcSbcSetMostNew (hCbo);
	return TRUE;
}
//----- `FbN{bNXit@CYt outlook Jj ----------------------------------------------//
AJC_DLGPROC(Divide, IDC_CHK_OUTLOOK	)
{
	if (AjcGetDlgItemChk(hDlg, IDC_CHK_OUTLOOK)) {
		AjcEnableDlgGroup(hDlg, IDC_GRP_OUTLOOK, TRUE , TRUE);
	}
	else {
		AjcEnableDlgGroup(hDlg, IDC_GRP_OUTLOOK, FALSE, FALSE);
	}
	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, IDCANCEL		)
{
	if (fBusy) {
		fCan = TRUE;
	}
	else {
		DestroyWindow(hDlg);
	}
	return TRUE;
}
//----- nj ---------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Divide, IDOK			)
{
	UTP		AppName = AJCLNGSEL(TEXT("t@C"), TEXT("File Divide"));
	UI		idDiv;
	SYSTEMTIME	st;
	HANDLE	hInp  = INVALID_HANDLE_VALUE;
	HANDLE	hOut  = INVALID_HANDLE_VALUE;
	BOOL	fErr  = FALSE;
	BOOL	fExit = FALSE;
	ULL		fsize;
	UL		att;
	UI		seq, maxnum;
	UT		drv    	[MAX_PATH];
	UT		dir    	[MAX_PATH];
	UT		InpDir	[MAX_PATH];			//	̓tH_pX
	UT		InpFile [MAX_PATH];			//	̓t@CpX
	UT		InpFName[MAX_PATH];			//	̓t@C
	UT		InpFExt [MAX_PATH];			//	̓t@Cgq
	UT		OutDir 	[MAX_PATH];			//	o̓tH_pX
	UT		OutFile	[MAX_PATH];			//	o̓t@CpX
	UT		OutWild [MAX_PATH];			//	o̓t@C̃ChJ[h
	UT		txt[128];

	//	hcݒ
	GetSystemTime(&st);
	idDiv = AjcSysTimeToTime1970(&st);

	//	~tOZbg
	fCan  = FALSE;
	//	stOZbg
	fBusy = TRUE;
	//	~{^O[
	AjcEnableDlgItem(hDlg, IDC_CMD_STOP, TRUE);
	//	vOXo[EZbg
	AjcSetDlgItemPgsPos(hDlg, IDC_PGS, 0);
	AjcShowDlgItem	   (hDlg, IDC_PGS, TRUE);

	do {
		//	pXt@C`FbN
		if (!AjcPathIsFile(ArgPath)) {
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("w肳ꂽt@C܂\n(%s)"),
													  TEXT("The specified file does not exist\n(%s)")), ArgPath);
			MessageBox(hDlg, txt, AppName, MB_ICONERROR);
			fErr = TRUE;
			break;
		}
		//	pXCt@Cݒ
		MAjcStrCpy	 (InpFile, MAX_PATH, ArgPath);
		MAjcSplitPath(InpFile, drv, dir, InpFName, InpFExt);
		MAjcMakePath (InpDir , drv, dir, NULL, NULL);
		//	o̓tH_pXݒ
		if (fDivDir) {
			MAjcStrCpy(OutDir, MAX_PATH, DivDir);
			AjcPathCat(OutDir, TEXT(""), MAX_PATH);
			if (!AjcPathIsDirectory(OutDir)) {
				AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("o͂Ɏw肵ꏊ̓tH_ł͂܂\n(%s)"), 
														  TEXT("The location specified for output is not a folder \n(%s)")), OutDir);
				MessageBox(hDlg, txt, AppName, MB_ICONERROR);
				fErr = TRUE;
				break;
			}
		}
		else {
			MAjcStrCpy(OutDir, MAX_PATH, InpDir);
		}
		//	t@CpChJ[hݒ
		AjcSnPrintF(OutWild, MAX_PATH, TEXT("%s%s%s(*.divide"), OutDir, InpFName, InpFExt);
		//	ɓ̕t@C݂ꍇAt@C̍폜₢킹
		if (!fDivRmv) {
			HANDLE	hFind;
			WIN32_FIND_DATAW fd;

			if ((hFind = FindFirstFileW(OutWild, &fd)) != INVALID_HANDLE_VALUE) {
				UT		fname[MAX_PATH];
				do {
					MAjcSplitPath(fd.cFileName, NULL, NULL, fname, NULL);
					if (IsDivFmtInFName(fname)) {
						if (MessageBox(hDlgMain, AJCLNGSEL(TEXT("̕t@C݂܂B\n\n")
														   TEXT("    폜܂H"),
												 		   TEXT("A divided file with the same name exists.\n\n")
														   TEXT("     Do you want to remove these?")), AppName, MB_YESNO) == IDNO) {
							fExit = TRUE;
						}
						break;
					}
				} while (FindNextFileW(hFind, &fd));
				FindClose(hFind);
				if (fExit) break;
			}
		}
		//	t@C폜
		EraseDivideFiles(OutWild);
		//	̓t@CTCYݒ
		fsize = AjcGetFileSize(InpFile);

		//	t@CTCYO
		if (fsize != 0) {
			ULL		fremain		= fsize;											//	coCg
			ULL		divsize		= DivSize * MB;										//	oCg
			ULL		bcount		= 0;												//	oCgJEg
			ULL		totalcount	= 0;												//	voCgJEg
			UL		rbytes, bytes;
			UI		per;
			UW		crc;
			UB		buf[BUFSIZE];

			//	Zo
			maxnum		= (UI)(fsize / divsize + ((fsize % divsize) != 0));	//	
			//	Rs[t@Cݒ
			att = GetFileAttributesW(InpFile);
			//	̓t@CI[v
			if ((hInp = CreateFile(InpFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {
				AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("̓t@CI[vł܂\n(%s)"),
														  TEXT("Unable to open input file\n(%s)")), InpFile);
				MessageBox(hDlg, txt, AppName, MB_ICONERROR);
				fErr = TRUE;
				break;
			}
			for (seq = 1; !(fCan || fErr) && seq <= maxnum && fremain > 0; seq++) {
				//	o̓t@Cݒ
				AjcSnPrintF(OutFile, MAX_PATH, TEXT("%s%s%s(%02d_of_%02d).divide"), OutDir, InpFName, InpFExt, seq, maxnum);
				//	o̓t@CI[v
				if ((hOut = CreateFileW(OutFile, GENERIC_WRITE, 0, NULL, CREATE_NEW, att, NULL)) == INVALID_HANDLE_VALUE) {
					AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("t@C쐬ł܂ł\n(%s)"), 
															  TEXT("Could not create divide file\n(%s)")), OutFile);
					MessageBox(hDlg, txt, AppName, MB_ICONERROR);
					fErr = TRUE;
					break;
				}
				//	hc
				if (!WriteFile(hOut, &idDiv, sizeof(idDiv), &bytes, NULL) || bytes != sizeof(idDiv)) {
					MessageBox(hDlg, AJCLNGSEL(TEXT("t@Chc݂̏ŃG[܂"),
											   TEXT("An error occurred while writing the divide file ID")),  AppName, MB_ICONERROR);
					break;
				}
				//	TCYo
				for (bcount = 0; !(fCan || fErr) && bcount < divsize && fremain > 0;) {
					//	WindowsbZ[W
					AjcDoEvent();
					if (fCan) break;
					//	̓t@Cǂݏo
					rbytes = (UI)__min(fremain, BUFSIZE);
					if (!ReadFile(hInp, buf, rbytes, &bytes, NULL) || rbytes != bytes) {
						MessageBox(hDlg, AJCLNGSEL(TEXT("̓t@C̓ǂݏoŃG[܂"),
										 		   TEXT("An error occurred while reading the input file")), AppName, MB_ICONERROR);
						fErr = TRUE;
						break;
					}
					//	o̓t@Cf[^
					if (!WriteFile(hOut, buf, rbytes, &bytes, NULL) || bytes != rbytes) {
						MessageBox(hDlg, AJCLNGSEL(TEXT("t@C݂̏ŃG[܂"),
												   TEXT("An error occurred while writing the divide file")),  AppName, MB_ICONERROR);
						break;
					}
					//	bqbZo
					crc = AjcBlkFCS(buf, rbytes);
					//	bqbo
					if (!WriteFile(hOut, &crc, 2, &bytes, NULL) || bytes != 2) {
						MessageBox(hDlg, AJCLNGSEL(TEXT("t@Ĉbqb݂ŃG[܂"),
												   TEXT("An error occurred while writing the CRC of the divide file.")), AppName, MB_ICONERROR);
						fErr = TRUE;
						break;
					}
					//	oCgJEgXV
					bcount	   += rbytes;
					totalcount += rbytes;
					//	t@CcTCYZ
					fremain -= rbytes;
					//	vOXo[\
					per = (UI)(totalcount * 100 / fsize);
					AjcSetDlgItemPgsPos(hDlg, IDC_PGS, per);
				}
				//	o̓t@CN[Y
				CloseHandle(hOut);
				hOut = INVALID_HANDLE_VALUE;
			}
		}
		//	̓TCYOȂ΁At@C쐬
		else {
			maxnum = 1;
			//	Rs[t@Cݒ
			att = GetFileAttributesW(InpFile);
			//	o̓t@Cݒ
			AjcSnPrintF(OutFile, MAX_PATH, TEXT("%s%s%s(%02d_of_%02d).divide"), OutDir, InpFName, InpFExt, 1, 1);
			//	o̓t@CI[v
			if ((hOut = CreateFileW(OutFile, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, att, NULL)) == INVALID_HANDLE_VALUE) {
				AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("t@C쐬ł܂ł\n(%s)"),
														  TEXT("Could not create divide file\n(%s)")), OutFile);
				MessageBox(hDlg, txt, AppName, MB_ICONERROR);
				fErr = TRUE;
				break;
			}
			//	o̓t@CN[Y
			CloseHandle(hOut);
			hOut = INVALID_HANDLE_VALUE;
		}
	} while(0);

	//	t@CN[Y
	if (hInp != INVALID_HANDLE_VALUE) CloseHandle(hInp);
	if (hOut != INVALID_HANDLE_VALUE) CloseHandle(hOut);

	//	IȂ΁EEE
	if (!(fCan || fErr || fExit)) {
		//	t@C̃tH_J
		if (fDivOpen) {
			ShellExecute(NULL, NULL, OutDir, TEXT(""), TEXT(""), SW_SHOW);
			Sleep(100);
		}
		//	Outlook N
		if (AjcGetDlgItemChk(hDlg, IDC_CHK_OUTLOOK)) {
			for (seq = 1; !(fCan || fErr) && seq <= maxnum; seq++) {
				HWND	hCbo = NULL;
				HWND	hEdt = NULL;
				UT		to	   [512]  = {0};
				UT		subject[512]  = {0};
				UT		cmd    [1024];
				UTP		p;
				//	敶ǂݏo
				hCbo = GetDlgItem(hDlg, IDC_CBO_TO);
				hEdt = AjcSbcGetEditCtrlInComboBox(hCbo);
				AjcGetCtrlStr(hEdt, to, AJCTSIZE(to));
				//	ǂݏo
				hCbo = GetDlgItem(hDlg, IDC_CBO_SUBJECT);
				hEdt = AjcSbcGetEditCtrlInComboBox(hCbo);
				AjcGetCtrlStr(hEdt, subject, AJCTSIZE(to));
				//	 "&N&"  "m/n" ɕϊ
				while (p = MAjcStrIStr(subject, TEXT("&N&"))) {
					UT	div[32];
					AjcSnPrintF(div, AJCTSIZE(div), TEXT("%d / %d"), seq, maxnum);
					AjcRepPartStr(subject, AJCTSIZE(subject), (UI)((UX)p - (UX)subject)/ sizeof(UT), 3, div, (UI)MAjcStrLen(div));
				}
				//	̋󔒂 "%20" ɕϊ
				while (p = MAjcStrStr(subject, TEXT(" "))) {
					AjcRepPartStr(subject, AJCTSIZE(subject), (UI)((UX)p - (UX)subject) / sizeof(UT), 1, TEXT("%20"), 3);
				}
				//	t@Cݒ
				AjcSnPrintF(OutFile, MAX_PATH, TEXT("%s%s%s(%02d_of_%02d).divide"), OutDir, InpFName, InpFExt, seq, maxnum);

				//	R}hC쐬
				if (AjcGetDlgItemChk(hDlg, IDC_RBT_QST)) AjcSnPrintF(cmd, AJCTSIZE(cmd), TEXT("/c ipm.note /m \"%s?subject=%s\" /a %s"), to, subject, OutFile);
				else									 AjcSnPrintF(cmd, AJCTSIZE(cmd), TEXT("/c ipm.note /m \"%s&subject=%s\" /a %s"), to, subject, OutFile);
				//	outlook N
				ShellExecute(NULL, NULL, TEXT("outlook.exe"), cmd, OutlookDir, SW_SHOW);
			}
		}
	}
	//	G[^~Ȃ΁Ao̓t@C폜
	else if (!fExit) {
		EraseDivideFiles(OutWild);
	}
	//	~{^O[ݒ
	AjcEnableDlgItem(hDlg, IDC_CMD_STOP, FALSE);

	//	stO
	fBusy = FALSE;

	#ifndef _DEBUG
		DestroyWindow(hDlg);
	#endif

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Divide)
	AJC_DLGMAP_MSG(Divide, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(Divide, WM_DESTROY 		)

	AJC_DLGMAP_CMD(Divide, IDC_CMD_STOP		)
	AJC_DLGMAP_CMD(Divide, IDC_CHK_OUTLOOK	)
	AJC_DLGMAP_CMD(Divide, IDC_CMD_TO		)
	AJC_DLGMAP_CMD(Divide, IDC_CMD_SUBJECT	)
	AJC_DLGMAP_CMD(Divide, IDCANCEL			)
	AJC_DLGMAP_CMD(Divide, IDOK				)
AJC_DLGMAP_END

//==============================================================================================================//
//																												//
//	_CAOEvV[W																				//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Merge, WM_INITDIALOG	)
{
	POINT	pt;
	UT		FileName[MAX_PATH];
	UT		fname[MAX_PATH];
	UT		fext [MAX_PATH];
	hDlgMerge = hDlg;

	//	peLXg
	SetWindowText(hDlg, AJCLNGSEL(TEXT("t@C̓"), TEXT("File Merge")));
	if (AjcGetLangId() != AJCLID_JPN) {
		AjcSetDlgItemStr(hDlg, IDC_LBL_INPFILE, TEXT("Divided file"));
		AjcSetDlgItemStr(hDlg, IDOK 	   , TEXT("Start merging divided files"));
		AjcSetDlgItemStr(hDlg, IDC_CMD_STOP, TEXT("Stop"));
	}

	//	ACR\
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcoDivide);
	//	vOXo[Wݒ
	AjcSetDlgItemPgsRange(hDlg, IDC_PGS, 0, 100);
	//	w肵t@C\
	MAjcSplitPath(ArgPath , NULL, NULL, fname, fext);
	MAjcMakePath (FileName, NULL, NULL, fname, fext);
	AjcSetDlgItemStr(hDlg, IDC_TXT_FNAME, FileName);

	//	EChJ[\ʒuֈړ
	GetCursorPos(&pt);
	SetWindowPos(hDlg, NULL, pt.x, pt.y, 0, 0, SWP_NOSIZE);
	AjcMoveWndIntoMonitor(hDlg);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Merge, WM_DESTROY		)
{
	PostQuitMessage(0);
	return TRUE;
}
//----- ~{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Merge, IDC_CMD_STOP		)
{
	PostMessage(hDlg, WM_COMMAND, IDCANCEL, (LPARAM)GetDlgItem(hDlg, IDCANCEL));
	return TRUE;
}
//----- LZ ----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Merge, IDCANCEL			)
{
	if (fBusy) {
		fCan = TRUE;
	}
	else {
		DestroyWindow(hDlg);
	}
	return TRUE;
}
//----- nj ---------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Merge, IDOK				)
{
	UTP		AppName		= AJCLNGSEL(TEXT("t@C"), TEXT("File Integrate"));
	HANDLE	hInp		= INVALID_HANDLE_VALUE;
	HANDLE	hOut		= INVALID_HANDLE_VALUE;
	HAJCAVS	hAvs		= NULL;
	PCAJCAVSPTR	pAvsStr	= NULL;
	UI		idDiv		= 0;
	BOOL	fErr  		= FALSE;
	ULL		fsize;
	UL		att;
	SYSTEMTIME lt;
	UT		szTime	[32];
	UT		drv    	[MAX_PATH];
	UT		dir    	[MAX_PATH];
	UT		fname	[MAX_PATH];
	UT		fext	[MAX_PATH];
	UT		OutDir 	[MAX_PATH];			//	o̓tH_pX
	UT		OutFile	[MAX_PATH];			//	o̓t@CpX
	UT		OutName [MAX_PATH];			//	o̓t@C(gqtj
	UT		txt[128];

	fCan  = FALSE;
	//	stOZbg
	fBusy = TRUE;
	//	~{^O[
	AjcEnableDlgItem(hDlg, IDC_CMD_STOP, TRUE);
	//	vOXo[EZbg
	AjcSetDlgItemPgsPos(hDlg, IDC_PGS, 0);
	AjcShowDlgItem	   (hDlg, IDC_PGS, TRUE);

	do {
		UI		maxnum = 0;
		//	pXt@C`FbN
		if (!AjcPathIsFile(ArgPath)) {
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("w肳ꂽt@C܂\n(%s)"),
													  TEXT("The specified file does not exist\n(%s)")), ArgPath);
			MessageBox(hDlg, txt, AppName, MB_ICONERROR);
			fErr = TRUE;
			break;
		}
		//	t@C擾
		att = GetFileAttributes(ArgPath);
		//	t@CTCY擾
		fsize = AjcGetFileSize(ArgPath);
		//	ݒ
		maxnum = IsDivFmtInFName(ArgPath);
		//	̓pXi[p񕪖ؐ
		hAvs = AjcAvsCreate (AJCCMP_IGNORE_WIDTH, 0, NULL);
		if (hAvs == NULL) {
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("G[i`ur쐬sj"), 
													  TEXT("Memory error (AVS creation failure)")));
			MessageBox(hDlg, txt, AppName, MB_ICONERROR);
			fErr = TRUE;
			break;
		}
		//	̓t@CpXW
		if (!CorrectDivideFiles(hAvs, maxnum)) {
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("́Et@C̎WɎs܂B"), 
													  TEXT("Failed to collect divided files.")));
			MessageBox(hDlg, txt, AppName, MB_ICONERROR);
			fErr = TRUE;
			break;
		}
		//	̓t@CpX̔z񐶐
		pAvsStr = AjcAvsCreatePtrArr(hAvs, NULL, FALSE);
		if (pAvsStr == NULL) {
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("G[it@CpXzj"), 
													  TEXT("Memory error (divide file path array)")));
			MessageBox(hDlg, txt, AppName, MB_ICONERROR);
			fErr = TRUE;
			break;
		}
		//	o̓tH_pXݒ
		if (fDivDir) {
			MAjcStrCpy(OutDir, MAX_PATH, DivDir);
			AjcPathCat(OutDir, TEXT(""), MAX_PATH);
			if (!AjcPathIsDirectory(OutDir)) {
				AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("o͂Ɏw肵ꏊ̓tH_ł͂܂\n(%s)"), 
														  TEXT("The location specified for output is not a folder \n(%s)")), OutDir);
				MessageBox(hDlg, txt, AppName, MB_ICONERROR);
				fErr = TRUE;
				break;
			}
		}
		else {
			MAjcSplitPath(ArgPath, drv, dir, NULL, NULL);
			MAjcMakePath (OutDir , drv, dir, NULL, NULL);
		}
		//	o̓tH_Ɂu\vt
		AjcPathCat(OutDir, TEXT(""), MAX_PATH);
		//	o̓t@Cĩt@C{jݒ
		ConvertToNormalName(ArgPath, OutName);
		//	o̓t@CpX쐬
		MAjcSplitPath(OutName, NULL, NULL, fname, fext);
		GetLocalTime(&lt);
		AjcSnPrintF(szTime, AJCTSIZE(szTime), TEXT("(%02d%02d%02d-%02d%02d%02d)"), lt.wYear % 100, lt.wMonth, lt.wDay, lt.wHour, lt.wMinute, lt.wSecond);
		MAjcStrCat(fname, MAX_PATH, szTime);
		MAjcStrCpy(OutFile, MAX_PATH, OutDir);
		AjcPathCat(OutFile, fname, MAX_PATH);
		AjcStrCat(OutFile, MAX_PATH, fext);

		//	o̓t@CI[v
		if ((hOut = CreateFileW(OutFile, GENERIC_WRITE, 0, NULL, CREATE_NEW, att, NULL)) == INVALID_HANDLE_VALUE) {
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("t@C쐬ł܂ł\n(%s)"), 
													  TEXT("Could not create divide file\n(%s)")), OutFile);
			MessageBox(hDlg, txt, AppName, MB_ICONERROR);
			fErr = TRUE;
			break;
		}

		//	t@CTCYO
		if (fsize != 0) {
			UI		i;
			UL		rbytes, wbytes, bytes;
			UI		per;
			ULL		totalcount = 0;		//	oCgJEg
			UB		buf[BUFSIZE + 2];
			//	̓t@C̍voCgZo
			fsize = 0;
			for (i = 0; i < maxnum; i++) {
				//	t@CTCYXV
				fsize += AjcGetFileSize(pAvsStr[i].pKey);
			}
			//	t@C
			for (i = 0; i < maxnum && !(fCan || fErr);i++) {
				//	̓t@CI[v
				if ((hInp = CreateFile(pAvsStr[i].pKey, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {
					AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("̓t@CI[vł܂\n(%s)"),
															  TEXT("Unable to open input file\n(%s)")), pAvsStr[i].pKey);
					MessageBox(hDlg, txt, AppName, MB_ICONERROR);
					fErr = TRUE;
					break;
				}
				//	hcXLbv
				if (!ReadFile(hInp, buf, sizeof idDiv, &bytes, NULL) || bytes != sizeof idDiv) {
					MessageBox(hDlg, AJCLNGSEL(TEXT("̓t@C̓ǂݏoŃG[܂"),
									 		   TEXT("An error occurred while reading the input file")), AppName, MB_ICONERROR);
					fErr = TRUE;
					break;
				}
				while (!(fCan || fErr)) {
					//	WindowsbZ[W
					AjcDoEvent();
					if (fCan) break;
					//	̓t@Cǂݏo
					rbytes = BUFSIZE + 2;
					if (!ReadFile(hInp, buf, rbytes, &bytes, NULL) || (bytes >= 1 && bytes <= 2)) {
						MessageBox(hDlg, AJCLNGSEL(TEXT("̓t@C̓ǂݏoŃG[܂"),
										 		   TEXT("An error occurred while reading the input file")), AppName, MB_ICONERROR);
						fErr = TRUE;
						break;
					}
					//	͏I`FbN
					if (bytes == 0) break;
					//	bqb`FbN
					if (!AjcChkFCS(buf, bytes)) {
						AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("f[^jĂ܂\n(%s)"),
																  TEXT("Divide data is corrupted\n(%s)")), pAvsStr[i].pKey);
						MessageBox(hDlg, txt, AppName, MB_ICONERROR);
						fErr = TRUE;
						break;
					}
					//	oCgJEgXV
					totalcount += rbytes;
					//	o̓t@Cf[^
					wbytes = bytes - 2;
					if (!WriteFile(hOut, buf, wbytes, &bytes, NULL) || bytes != wbytes) {
						MessageBox(hDlg, AJCLNGSEL(TEXT("t@C݂̏ŃG[܂"),
												   TEXT("An error occurred while writing the integrate file")),  AppName, MB_ICONERROR);
						break;
					}
					//	vOXo[\
					per = (UI)(totalcount * 100 / fsize);
					AjcSetDlgItemPgsPos(hDlg, IDC_PGS, per);
				}
				//	̓t@CN[Y
				CloseHandle(hInp);
				hInp = INVALID_HANDLE_VALUE;
			}
		}
		//	t@CTCYO
		else {
			//	NOP
		}
		//	o̓t@CN[Y
		CloseHandle(hOut);
		hOut = INVALID_HANDLE_VALUE;
	} while(0);

	//	t@CN[Y
	if (hInp != INVALID_HANDLE_VALUE) CloseHandle(hInp);
	if (hOut != INVALID_HANDLE_VALUE) CloseHandle(hOut);

	//	񕪖ؔj
	if (pAvsStr != NULL) AjcAvsReleasePtrArr(hAvs, pAvsStr);
	if (hAvs	!= NULL) AjcAvsDelete(hAvs);

	//	IȂ΁At@C̏ꏊJ
	if (!(fCan || fErr)) {
		if (fDivOpen) {
			ShellExecute(NULL, NULL, OutDir, TEXT(""), TEXT(""), SW_SHOW);
			Sleep(100);
		}
	}
	//	G[^~Ȃ΁Ao̓t@C폜
	else {
		SetFileAttributes(OutFile, FILE_ATTRIBUTE_NORMAL);
		DeleteFile(OutFile);
	}

	//	~{^O[ݒ
	AjcEnableDlgItem(hDlg, IDC_CMD_STOP, FALSE);

	//	stONA[
	fBusy = FALSE;

	//	vOI
	#ifndef _DEBUG
		DestroyWindow(hDlg);
	#endif

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Merge)
	AJC_DLGMAP_MSG(Merge, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Merge, WM_DESTROY 		)

	AJC_DLGMAP_CMD(Merge, IDC_CMD_STOP		)
	AJC_DLGMAP_CMD(Merge, IDCANCEL			)
	AJC_DLGMAP_CMD(Merge, IDOK				)
AJC_DLGMAP_END

//==============================================================================================================//
//																												//
//	ݒ_CAOEvV[W																				//
//																												//
//==============================================================================================================//

BOOL	fSettingValid = FALSE;

//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, WM_INITDIALOG )
{
	hDlgSetting = hDlg;

	//	ݒ̓dN}~
	if ((hMuteDupSetting = OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTE_DUP_APP)) != NULL) {
		//	ݒ_CAOANeBu
		SendMessage(HWND_BROADCAST, RegisterWindowMessage(TEXT("AjrActSet")), 0, 0);
		//	~[ebNXJ
		ReleaseMutex(hMuteDupSetting);
		hMuteDupSetting = NULL;
		//	EChj
		DestroyWindow(hDlg);
		return TRUE;
	}

	//	dN}~v~[ebNX
	hMuteDupSetting = CreateMutex(NULL, FALSE, MUTE_DUP_APP);

	//	EChʒu[h
	AjcLoadWndPos(hDlg, MYSECT);

	//	peLXg
	if (AjcGetLangId() != AJCLID_JPN) {
		SetWindowText(hDlg, TEXT("File Division/Merge settings"));
		AjcSetDlgItemStr (hDlg, IDC_GRP_DIV, TEXT("File Division"));
		AjcSetDlgItemStr (hDlg, IDC_GRP_DIVPOS , TEXT("Folder to store"));
		AjcSetDlgItemStr (hDlg, IDC_RBT_DIVTHIS, TEXT("Ssame folder as original file"));
		AjcSetDlgItemStr (hDlg, IDC_RBT_DIVDIR , TEXT("Specified folder"));
		AjcSetDlgItemStr (hDlg, IDC_LBL_DIVSIZE, TEXT("Division Size"));
		AjcSetDlgItemStr (hDlg, IDC_CHK_DIVOPEN, TEXT("Once the files have been divided, open the divided file folder."));
		AjcSetDlgItemStr (hDlg, IDC_CHK_DIVRMV , TEXT("If there is already a split file with the same name, delete it."));
		AjcSetDlgItemStr (hDlg, IDC_GRP_MRG    , TEXT("File Merge"));
		AjcSetDlgItemStr (hDlg, IDC_GRP_MRGPOS , TEXT("Folder to store"));
		AjcSetDlgItemStr (hDlg, IDC_RBT_MRGTHIS, TEXT("Same folder as division file"));
		AjcSetDlgItemStr (hDlg, IDC_RBT_MRGDIR , TEXT("Specified folder"));
		AjcSetDlgItemStr (hDlg, IDC_CHK_MRGOPEN, TEXT("Once the files have been merged, open the merged file folder."));
		AjcSetDlgItemStr (hDlg, IDC_CHK_MRGRMV , TEXT("Delete the division files once the files have been merged."));
	}

	//	WI{^̃O[v
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_DIVPOS));
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_MRGPOS));

	//	tH_hbv
	AjcEnableDlgItemToDrop(hDlg, IDC_TXT_DIVDIR, AJCDROP_DIR);
	AjcEnableDlgItemToDrop(hDlg, IDC_TXT_MRGDIR, AJCDROP_DIR);

	SetWindowPos(GetDlgItem(hDlg, IDC_GRP_OUTLOOK), HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	AjcEnableDlgItemToDrop(hDlg, IDC_TXT_OLDIR, AJCDROP_DIR);

	//	_CAOڐݒ
	AjcSetDlgItemUInt(hDlg, IDC_INP_DIVSIZE,  DivSize );
	AjcSetDlgItemUInt(hDlg, IDC_GRP_DIVPOS ,  fDivDir );
	AjcSetDlgItemChk (hDlg, IDC_CHK_DIVOPEN,  fDivOpen);
	AjcSetDlgItemChk (hDlg, IDC_CHK_DIVRMV ,  fDivRmv );
	AjcSetDlgItemStr (hDlg, IDC_TXT_DIVDIR ,  DivDir  );

	AjcSetDlgItemUInt(hDlg, IDC_GRP_MRGPOS ,  fMrgDir );
	AjcSetDlgItemChk (hDlg, IDC_CHK_MRGOPEN,  fMrgOpen);
	AjcSetDlgItemChk (hDlg, IDC_CHK_MRGRMV ,  fMrgRmv );
	AjcSetDlgItemStr (hDlg, IDC_TXT_MRGDIR ,  MrgDir  );

	AjcSetDlgItemStr (hDlg, IDC_TXT_OLDIR  , OutlookDir );
	AjcSetDlgItemStr (hDlg, IDC_LBL_OLDESC , OutlookDesc);
	AjcSetDlgItemStr (hDlg, IDC_LBL_OLVER  , OutlookVer );

	//	WI{^
	AjcSetDlgItemUInt(hDlg, IDC_GRP_DIVPOS, fDivDir);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_MRGPOS, fMrgDir);

	//	^C}ŒxoutlookݒL
	SetTimer(hDlg, TID_ENABLE_SET_TXT_OLDIR, 10, FALSE);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, WM_DESTROY	)
{
	//	EChʒuZ[u
	AjcSaveWndPos(hDlg, MYSECT);

	//	dN}~v~[ebNXj
	CloseHandle(hMuteDupSetting);
	hMuteDupSetting = NULL;

	PostQuitMessage(0);
	return TRUE;
}
//----- WM_TIMER -----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, WM_TIMER	)
{
	if (wParam == TID_ENABLE_SET_TXT_OLDIR) {
		KillTimer(hDlg, 1);
		fSettingValid = TRUE;
	}
	return TRUE;
}
//-----  WM_ACT_SET --------------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, WM_ACT_SET	)
{
	AjcSetFocusWindow(hDlg);
	return TRUE;
}
//----- t@Ci[ꏊ̑I -----------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDC_GRP_DIVPOS	)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		if (fDivDir = (BOOL)lParam) {
			AjcEnableDlgItem(hDlg, IDC_TXT_DIVDIR, TRUE);
			AjcEnableDlgItem(hDlg, IDC_CMD_DIVDIR, TRUE);
		}
		else {
			AjcEnableDlgItem(hDlg, IDC_TXT_DIVDIR, FALSE);
			AjcEnableDlgItem(hDlg, IDC_CMD_DIVDIR, FALSE);
		}
	}
	return TRUE;
}
//----- t@Ci[tH_ݒ ---------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDC_CMD_DIVDIR	)
{
	UT	path[MAX_PATH];
	MAjcStrCpy(path, MAX_PATH, DivDir);
	if (AjcGetFolderName(hDlg, AJCLNGSEL(TEXT("t@Ci[ꏊ"),
										 TEXT("Folder to store divide files")), path, path, FALSE)) {
		MAjcStrCpy(DivDir, MAX_PATH, path);
	}
	return TRUE;
}
//----- t@Ci[ꏊ̑I -----------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDC_GRP_MRGPOS	)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		if (fMrgDir = (BOOL)lParam) {
			AjcEnableDlgItem(hDlg, IDC_TXT_MRGDIR, TRUE);
			AjcEnableDlgItem(hDlg, IDC_CMD_MRGDIR, TRUE);
		}
		else {
			AjcEnableDlgItem(hDlg, IDC_TXT_MRGDIR, FALSE);
			AjcEnableDlgItem(hDlg, IDC_CMD_MRGDIR, FALSE);
		}
	}
	return TRUE;
}
//----- t@Ci[tH_ݒ ---------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDC_CMD_MRGDIR	)
{
	UT	path[MAX_PATH];

	if (HIWORD(wParam) == BN_CLICKED) {
		MAjcStrCpy(path, MAX_PATH, MrgDir);
		if (AjcGetFolderName(hDlg, AJCLNGSEL(TEXT("t@Ci[ꏊ"),
											 TEXT("Folder to store divide files")), path, path, FALSE)) {
			MAjcStrCpy(MrgDir, MAX_PATH, path);
		}
	}
	return TRUE;
}
//----- Outlook pXݒ --------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDC_CMD_OUTLOOK)
{
	UT		path  [MAX_PATH] = {0};
	UT		drv   [MAX_PATH] = {0};
	UT		dir   [MAX_PATH] = {0};
	UT		ol_dir[MAX_PATH] = {0};
	UT		desc  [256]		 = {0};
	UT		fver  [256]		 = {0};

	if (HIWORD(wParam) == BN_CLICKED) {
		MAjcStrCpy(path, MAX_PATH, MrgDir);
		if (AjcGetFolderName(hDlg, AJCLNGSEL(TEXT("Outlook.exȅꏊ"),
											 TEXT("Outlook.exe folder path")), path, path, FALSE)) {
			AjcSetDlgItemStr(hDlg, IDC_TXT_OLDIR, path);
		}
	}
	return TRUE;
}
//----- Outlook pXeLXgύX ------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDC_TXT_OLDIR	)
{
	UT		path  [MAX_PATH] = {0};
	UT		drv   [MAX_PATH] = {0};
	UT		dir   [MAX_PATH] = {0};

	if (fSettingValid) {
		AjcGetDlgItemStr(hDlg, IDC_TXT_OLDIR, path, MAX_PATH);
		AjcPathCat(path, TEXT("outlook.exe"), MAX_PATH);
		if (AjcPathIsFile(path)) {
			//	t@Co[WALqǂݏo
			OutlookDesc[0] = 0;
			OutlookVer [0] = 0;
			AjcGetVerInfo(path, AJCVERINFO_FILE_DESCRIPTION, OutlookDesc, AJCTSIZE(OutlookDesc));
			AjcGetVerInfo(path, AJCVERINFO_FILE_VERSION	   , OutlookVer , AJCTSIZE(OutlookVer ));
			//	fBNgpX쐬
			MAjcSplitPath(path		, drv, dir, NULL, NULL);
			MAjcMakePath (OutlookDir, drv, dir, NULL, NULL);
			PathRemoveBackslash(OutlookDir);
			//	WXg֋L^
			AjcPutProfileStr (MYSECT, TEXT("OutlookDir" ), OutlookDir);
			AjcPutProfileStr (MYSECT, TEXT("OutlookDesc"), OutlookDesc);
			AjcPutProfileStr (MYSECT, TEXT("OutlookVer" ), OutlookVer);
			//	Outlook\
			fSettingValid = FALSE;
			AjcSetDlgItemStr (hDlg, IDC_TXT_OLDIR , OutlookDir );
			AjcSetDlgItemStr (hDlg, IDC_LBL_OLDESC, OutlookDesc);
			AjcSetDlgItemStr (hDlg, IDC_LBL_OLVER , OutlookVer );
			SetTimer(hDlg, TID_ENABLE_SET_TXT_OLDIR, 10, NULL);
		}
		else {
			UT	txt[512];
			UT	ttl[256];
			AjcDoEvent();
			GetWindowText(hDlg, ttl, AJCTSIZE(ttl));
			AjcGetDlgItemStr(hDlg, IDC_TXT_OLDIR, path, MAX_PATH);
			AjcSnPrintF(txt, AJCTSIZE(txt), AJCLNGSEL(TEXT("Outlook.exe ܂\n(%s)"),
									  TEXT("Outlook.exe not found\n(%s)")), path);
			MessageBox(hDlg,txt, ttl, MB_ICONERROR);
			fSettingValid = FALSE;
			AjcSetDlgItemStr(hDlg, IDC_TXT_OLDIR, OutlookDir);
			SetTimer(hDlg, TID_ENABLE_SET_TXT_OLDIR, 10, NULL);
		}
	}
	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDCANCEL		)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- nj ---------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Setting, IDOK			)
{
	DivSize  = AjcGetDlgItemUInt(hDlg, IDC_INP_DIVSIZE);
	fDivDir  = AjcGetDlgItemUInt(hDlg, IDC_GRP_DIVPOS );
	fDivOpen = AjcGetDlgItemChk (hDlg, IDC_CHK_DIVOPEN);
	fDivRmv  = AjcGetDlgItemChk (hDlg, IDC_CHK_DIVRMV );
	AjcGetDlgItemStr(hDlg, IDC_TXT_DIVDIR, DivDir, MAX_PATH);

	fMrgDir  = AjcGetDlgItemUInt(hDlg, IDC_GRP_MRGPOS );
	fMrgOpen = AjcGetDlgItemChk (hDlg, IDC_CHK_MRGOPEN);
	fMrgRmv  = AjcGetDlgItemChk (hDlg, IDC_CHK_MRGRMV );
	AjcGetDlgItemStr(hDlg, IDC_TXT_MRGDIR, MrgDir, MAX_PATH);

	//	i񏑂
	AjcPutProfileUInt(MYSECT, TEXT("DivSize" ), DivSize );
	AjcPutProfileUInt(MYSECT, TEXT("fDivDir" ), fDivDir );
	AjcPutProfileUInt(MYSECT, TEXT("fDivOpen"), fDivOpen);
	AjcPutProfileUInt(MYSECT, TEXT("fDivRmv" ), fDivRmv );
	AjcPutProfileStr (MYSECT, TEXT("DivDir"  ), DivDir	);

	AjcPutProfileUInt(MYSECT, TEXT("fMrgDir" ), fMrgDir );
	AjcPutProfileUInt(MYSECT, TEXT("fMrgOpen"), fMrgOpen);
	AjcPutProfileUInt(MYSECT, TEXT("fMrgRmv" ), fMrgRmv );
	AjcPutProfileStr (MYSECT, TEXT("MrgDir"  ), MrgDir	);

	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Setting)
	AJC_DLGMAP_MSG(Setting, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(Setting, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Setting, WM_TIMER 		)
	AJC_DLGMAP_RWM(Setting, WM_ACT_SET 		, TEXT("AjrActSet"))

	AJC_DLGMAP_CMD(Setting, IDC_GRP_DIVPOS	)
	AJC_DLGMAP_CMD(Setting, IDC_CMD_DIVDIR	)
	AJC_DLGMAP_CMD(Setting, IDC_GRP_MRGPOS	)
	AJC_DLGMAP_CMD(Setting, IDC_CMD_MRGDIR	)
	AJC_DLGMAP_CMD(Setting, IDC_CMD_OUTLOOK	)
	AJC_DLGMAP_CMD(Setting, IDC_TXT_OLDIR	)
	AJC_DLGMAP_CMD(Setting, IDCANCEL		)
	AJC_DLGMAP_CMD(Setting, IDOK			)
AJC_DLGMAP_END
//==============================================================================================================//
//																												//
//	_CAOETuNX vV[WiENbNj[j													//
//																												//
//==============================================================================================================//
enum {
	IDM_DOC				=	5001,		//	\
	IDM_VER						,		//	o[W\
};
//----- ENbN ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(DlgSub, WM_RBUTTONDOWN	)
{
	HMENU		hMenu	= NULL;
	int			id;
	POINT		pt;

	hMenu = CreatePopupMenu();
	AppendMenu(hMenu, MFT_STRING, IDM_DOC	, AJCLNGSEL(TEXT("\"), TEXT("Show Document")));
	AppendMenu(hMenu, MFT_STRING, IDM_VER	, AJCLNGSEL(TEXT("o[W"), TEXT("Version"		)));
	GetCursorPos(&pt);
	id = AjcDgcTrackPopupMenuEx(hMenu, TPM_RETURNCMD | TPM_TOPALIGN, pt.x, pt.y, hwnd, NULL);
	DestroyMenu(hMenu);

	switch (id) {
		case IDM_DOC:					//	\
		{	UT		path[MAX_PATH];
			AjcGetAppPath(path, MAX_PATH);
			AjcPathCat(path, TEXT("FileDiv.pdf"), MAX_PATH);
			ShellExecute(NULL, NULL, path, TEXT(""), TEXT(""), SW_SHOW);
			break;
		}
		case IDM_VER:					//	o[W\
		{	UT	txt[128];
			AjcGetVerInRes(hInst, txt, AJCTSIZE(txt));
			AjcAjrAppVersionDialogEx(hwnd, txt,  (UX)hIcoDivide, 2024,
									 AJCLNGSEL(TEXT("t@C^"), TEXT("File divide / integrate")),
									 AJCLNGSEL(TEXT("o[W"), TEXT("Version information")),
									 TEXT("Ajara"),
									 AJCVER_ICON);
			break;
		}
	}
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(DlgSub)
	AJC_WNDMAP_MSG(DlgSub, WM_RBUTTONDOWN	)
AJC_WNDMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	t@C猳̃t@Cݒ																		//
//																												//
//	@	:	pDiv	- t@C^pX																//
//				buf		- ̃t@Ci[obt@														//
//																												//
//	߂l	:	TRUE  - nj																					//
//				FALSE - G[	it@CłȂj															//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	ConvertToNormalName(C_UTP pDiv, UT buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	UI		i, stl;
	UT		div  [MAX_PATH] = {0};
	UT		fname[MAX_PATH] = {0};
	UT		fext [MAX_PATH] = {0};
	UT		std  [MAX_PATH] = {0};
//	SYSTEMTIME lt;
//	UT		szTime[64];

	//	̃t@C{gqCgq(.divide)ɕiAAOutlook LbV̏ꍇt@C(nnn)t̏ꍇj
	MAjcSplitPath(pDiv, NULL, NULL, div, fext);
	stl = (UI)MAjcStrLen(div);

	if (stl >= LEN_DIVSTR) {
		//	̃t@Cݒi"mm_of_nn"̒O܂ł̃t@Cj
		if (stl >= LEN_DIVSTR) {
			for (i = 0; i <= stl - LEN_DIVSTR; i++) {
				if (rc = IsDivFmtStr(&div[i])) {
					buf[i] = 0;
					div[i] = 0;
					break;
				}
				else {
					buf[i] = fname[i];
				}
			}
			//	t@CƊgqɕ
			MAjcSplitPath(div, NULL, NULL, fname, fext);

			MAjcMakePath (std, NULL, NULL, fname, fext);
			MAjcStrCpy(buf, MAX_PATH, std);
			rc = TRUE;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	t@CQ폜																						//
//																												//
//	@	:	pWild	- t@C̃ChJ[h															//
//																												//
//	߂l	:	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	EraseDivideFiles(C_UTP pWild)
{
	HANDLE	hFind;
	UT		drv  [MAX_PATH];
	UT		dir  [MAX_PATH];
	UT		fname[MAX_PATH];
	UT		path [MAX_PATH];
	WIN32_FIND_DATAW fd;

	if ((hFind = FindFirstFileW(pWild, &fd)) != INVALID_HANDLE_VALUE) {
		BOOL	fExit = FALSE;
		do {
			MAjcSplitPath(fd.cFileName, NULL, NULL, fname, NULL);
			if (IsDivFmtInFName(fname)) {
				MAjcSplitPath(pWild, drv, dir, NULL, NULL);
				MAjcMakePath (path , drv, dir, NULL, NULL);
				AjcPathCat(path, fd.cFileName, MAX_PATH);
				SetFileAttributes(path, FILE_ATTRIBUTE_NORMAL);
				DeleteFile(path);
			}
		} while (FindNextFileW(hFind, &fd));
		FindClose(hFind);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	t@Cɕ`(mm_of_nn)܂܂邩`FbN													//
//																												//
//	@	:	pFName	- t@C																			//
//																												//
//	߂l	:	0 : vij																			//
//				0 : sv																					//
//--------------------------------------------------------------------------------------------------------------//
static	UI	IsDivFmtInFName(C_UTP pFName)
{
	UI		rc = 0;
	UI		i, stl;

	stl = (UI)MAjcStrLen(pFName);
	if (stl >= LEN_DIVSTR) {
		for (i = 0; i <= stl - LEN_DIVSTR; i++) {
			if (rc = IsDivFmtStr(pFName + i)) {
				break;
			}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	`(mm_of_nn)`FbN																			//
//																												//
//	@	:	pStr	- `FbN镶																	//
//																												//
//	߂l	:	0 : vij																			//
//				0 : sv																					//
//--------------------------------------------------------------------------------------------------------------//
static	UI	IsDivFmtStr(C_UTP pStr)
{
	UI		rc	= 0;
	UI		stl = MAjcStrLen(pStr);;

	if (stl >= LEN_DIVSTR) {
		if (pStr[0] == TEXT('(') &&
			MAjcIsDigit(pStr[1]) &&
			MAjcIsDigit(pStr[2]) &&
			pStr[3] == TEXT('_') &&
			pStr[4] == TEXT('o') &&
			pStr[5] == TEXT('f') &&
			pStr[6] == TEXT('_') &&
			MAjcIsDigit(pStr[7]) &&
			MAjcIsDigit(pStr[8]) &&
			pStr[9] == TEXT(')')) {

			rc = AjcAscToInt(pStr + 7);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	́Et@CpXW																					//
//																												//
//	@	:	hAvs	- Q؃nh																		//
//				maxnum	- ̓t@C																		//
//																												//
//	߂l	:	TRUE  : OK																						//
//				FALSE : G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CorrectDivideFiles(HAJCAVS hAvs, UI maxnum)
{
	BOOL	rc		= FALSE;
	HANDLE	hInp	= INVALID_HANDLE_VALUE;
	UI		idOrg	= 0;
	UI		idDiv	= 0;
	UL		bytes;
	UT		drv    [MAX_PATH] = {0};
	UT		dir    [MAX_PATH] = {0};
	UT		org    [MAX_PATH] = {0};
	UT		wild   [MAX_PATH] = {0};
	UT		InpPath[MAX_PATH] = {0};
	HANDLE	hFind;
	WIN32_FIND_DATAW fd;

	do {
		//	hcݒ
		if ((hInp = CreateFile(ArgPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) break;
		if (!ReadFile(hInp, &idOrg, sizeof(idOrg), &bytes, NULL) || (bytes != sizeof(idOrg))) break;
		CloseHandle(hInp);
		//	̃t@Cݒ
		ConvertToNormalName(ArgPath, org);
		//	ChJ[hݒ
		MAjcStrCat(org, MAX_PATH, TEXT("*"));
		MAjcSplitPath(ArgPath, drv, dir, NULL, NULL);
		MAjcMakePath (wild	 , drv, dir, org , TEXT(".divide"));
		//	̓t@C
		if ((hFind = FindFirstFileW(wild, &fd)) != INVALID_HANDLE_VALUE) {
			do {
				if (IsDivFmtInFName(fd.cFileName)) {
					MAjcMakePath(InpPath, drv, dir, NULL, NULL);
					AjcPathCat(InpPath, fd.cFileName, MAX_PATH);
					if ((hInp = CreateFile(InpPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE) {
						if (ReadFile(hInp, &idDiv, sizeof idDiv, &bytes, NULL) && bytes == sizeof idDiv) {
							if (idOrg == idDiv) {
								if (!AjcAvsInsNode(hAvs, InpPath, NULL, 0)) goto cdf_exit;
							}
						}
						CloseHandle(hInp);
						hInp = INVALID_HANDLE_VALUE;
					}
				}
			} while (FindNextFileW(hFind, &fd));
			FindClose(hFind);
			hFind = INVALID_HANDLE_VALUE;
		}
	} while(0);
	//	߂lݒ
	if (AjcAvsGetCount(hAvs) == maxnum) {
		rc = TRUE;
	}

cdf_exit:;

	//	t@CN[Y
	if (hInp  != INVALID_HANDLE_VALUE) CloseHandle(hInp );
	//	N[Y
	if (hFind != INVALID_HANDLE_VALUE) CloseHandle(hFind);

	return rc;
}
